/*
 * Main.cpp
 *
 *  Created on: 12/giu/2010
 *      Author: fisch
 */

#define CV_NO_BACKWARD_COMPATIBILITY

#include "cv.h"
#include "highgui.h"

#include <iostream>
#include <cstdio>

//#include "Detector.h"
#include "FaceDetector.h"

//opengl related includes
#include <GL/glut.h>    // Header File For The GLUT Library
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <GL/freeglut.h>

using namespace std;
using namespace cv;

String frontalCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_frontalface_alt2.xml";
String profileCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_profileface.xml";
String rEyeCascadeName =
"/usr/local/share/opencv/haarcascades/ojoD.xml";
String lEyeCascadeName =
"/usr/local/share/opencv/haarcascades/ojoI.xml";
String noseCascadeName =
"/usr/local/share/opencv/haarcascades/Nariz.xml";
String mouthCascadeName =
"/usr/local/share/opencv/haarcascades/Mouth.xml";
char rawFile[] =
"/home/fisch/head.raw";

GLuint	keyframeTexture;
/* white ambient light at half intensity (rgba) */
GLfloat LightAmbient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
/* super bright, full intensity diffuse light. */
GLfloat LightDiffuse[] = { 0.8f, 0.8f, 0.8, 1.0f };
GLfloat LightSpecular[] = { 0.5f, 0.5f, 0.5f, 1.0f };
/* position of light (x, y, z, (position of light)) */
GLfloat LightPosition[] = { 0.0f, 0.0f, 0.0f, 1.0f };
/* openGl texture to store grabbed frame */
GLuint	frameTexture;
/* The number of our GLUT window */
int window;

struct triangle { float vert[3][3]; };
triangle triangles[3036];

double projectionMatrix[16];

VideoCapture camera;
Mat currentFrame;
//Detector detector;
FaceDetector detector2;

double scale = 2.0;
double t1 = 0.0, t2 = 0.0;
bool detected = false, drawSine = false, drawHead = true, drawAxis = true, drawText = true, start = false;

void loadRaw( char* file )
{
	FILE* in = fopen( file, "r" );
	if(!in){
		printf("Cannot find head.raw file with head vertices. This file should be in a subdirectory data in the directory from which the application is being run.\n");
		exit(EXIT_FAILURE);
	}

	int tcount = 0;
	float mScale = 1.0;
	float deltaX = 0.0, deltaY = 0.0, deltaZ = 0.0;
	float p1[3], p2[3], p3[3];

	while( fscanf(in,"%f%f%f%f%f%f%f%f%f",&p1[0],&p1[1],&p1[2],&p2[0],&p2[1],&p2[2],&p3[0],&p3[1],&p3[2]) != EOF )
	{
		triangles[tcount].vert[0][0]=(p1[0]+deltaX)*mScale;
		triangles[tcount].vert[0][1]=(p1[1]+deltaY)*mScale;
		triangles[tcount].vert[0][2]=(p1[2]+deltaZ)*mScale;

		triangles[tcount].vert[1][0]=(p2[0]+deltaX)*mScale;
		triangles[tcount].vert[1][1]=(p2[1]+deltaY)*mScale;
		triangles[tcount].vert[1][2]=(p2[2]+deltaZ)*mScale;

		triangles[tcount].vert[2][0]=(p3[0]+deltaX)*mScale;
		triangles[tcount].vert[2][1]=(p3[1]+deltaY)*mScale;
		triangles[tcount].vert[2][2]=(p3[2]+deltaZ)*mScale;

		tcount++;
	}
	fclose(in);
}

void setGLProjectionMatrix( double projectionMatrix[16] )
{
	double farPlane = 10000.0;
	double nearPlane = 1.0;
	double width = 640;
	double height = 480;
	double focalLength = EHCIFOCUS;

	projectionMatrix[0] = 2.0 * focalLength / width;
	projectionMatrix[1] = 0.0;
	projectionMatrix[2] = 0.0;
	projectionMatrix[3] = 0.0;

	projectionMatrix[4] = 0.0;
	projectionMatrix[5] = 2.0 * focalLength / height;
	projectionMatrix[6] = 0.0;
	projectionMatrix[7] = 0.0;

	projectionMatrix[8] = 0;
	projectionMatrix[9] = 0;
	projectionMatrix[10] =-( farPlane+nearPlane ) / ( farPlane - nearPlane );
	projectionMatrix[11] =-1.0;

	projectionMatrix[12] = 0.0;
	projectionMatrix[13] = 0.0;
	projectionMatrix[14] =-2.0 * farPlane * nearPlane / ( farPlane - nearPlane );
	projectionMatrix[15] = 0.0;
}

void drawCentralAxis()
{
	float deltaX,deltaY,deltaZ;
	detector2.getReferenceCoordinate( deltaX, deltaY, deltaZ );

	float cx,cy,cz;
	cx = .5 - deltaX;
	cy = -.25 - deltaY;
	cz = 1.0 - deltaZ;

	glLineWidth(4.0);
	glBegin(GL_LINES);
	glColor3f(1.0f,0.0f,0.0);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx+1000,cy,cz);
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.9f,0.3f,0.0);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx -1000,cy,cz);
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.0f,1.0f,0.0);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx,cy+1000,cz);
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.3f,0.8f,0.0);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx,cy-1000,cz);
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.0f,0.0f,1.0);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx,cy,cz+5.0f);
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.0f,0.0f,0.5f);
	glVertex3f( cx,cy,cz);
	glVertex3f( cx,cy,cz-5.0f);
	glEnd();
	glLineWidth(1.0);
}

void drawSinusoidalHead( float scale )
{
	float deltaX,deltaY,deltaZ;
	detector2.getReferenceCoordinate( deltaX, deltaY, deltaZ );

	glBindTexture(GL_TEXTURE_2D, keyframeTexture);

	//this code will map only the texture detail
	double xIncrement = 0.01;
	for( double x = 0; x <= 1.0 - xIncrement; x += xIncrement)
	{
		glBegin(GL_QUADS);

		glColor3f(1.0f,1.0f,1.0f);

		glTexCoord2f( x, 0 );
		glVertex3f(0 + x - deltaX, 0.0 - deltaY, .5*sin(x*3.141593) - deltaZ);

		glTexCoord2f( x, 1.0);
		glVertex3f(0 + x - deltaX, -1.0 - deltaY, .5*sin(x*3.141593) - deltaZ);

		glTexCoord2f( x+xIncrement, 1.0);
		glVertex3f(0 + x + xIncrement - deltaX, -1.0 - deltaY, .5*sin((x+xIncrement)*3.141593) - deltaZ);

		glTexCoord2f( x + xIncrement, 0.0);
		glVertex3f(0 + x + xIncrement - deltaX, 0.0 - deltaY, .5*sin((x+xIncrement)*3.141593) - deltaZ);

		glEnd();
	}

	glBindTexture(GL_TEXTURE_2D, 0);
}

void drawHeadModel( float scale )
{
	float deltaX = 0.0;
	float deltaY = 0.0;
	float deltaZ = 0.0;

	detector2.getReferenceCoordinate( deltaX, deltaY, deltaZ );
	deltaX-=0.5;
	deltaY+=0.5;
	deltaZ+=0.5;

	for( int i = 0; i < 3036; i++ )
	{
		if( drawText )
		{
			float v1x = triangles[i].vert[1][0] - triangles[i].vert[0][0];
			float v1y = triangles[i].vert[1][1] - triangles[i].vert[0][1];
			float v1z = triangles[i].vert[1][2] - triangles[i].vert[0][2];

			float v2x = triangles[i].vert[2][0] - triangles[i].vert[0][0];
			float v2y = triangles[i].vert[2][1] - triangles[i].vert[0][1];
			float v2z = triangles[i].vert[2][2] - triangles[i].vert[0][2];

			float nx = 5*(v1y*v2z-v2y*v1z);
			float ny = 5*(v1z*v2x-v2z*v1x);
			float nz = 5*(v1x*v2y-v2x*v1y);

		    // calculate the length of the vector
		    float len = (float)(sqrt((nx * nx) + (ny * ny) + (nz * nz)));

		    // avoid division by 0
		    if (len == 0.0f)
		        len = 1.0f;

		    // reduce to unit size
		    nx /= len;
		    ny /= len;
		    nz /= len;

			glNormal3f(nx,ny,nz);
		}

		glBegin(GL_TRIANGLES);
		glColor4d (1.0, 1.0, 1.0,0.65);

		for( int j = 0; j < 3; j++ )
			glVertex3f(	scale* (triangles[i].vert[j][0])-deltaX,
						scale* (triangles[i].vert[j][1])-deltaY,
						scale* (triangles[i].vert[j][2])-deltaZ );

		glEnd();
	}
}

void drawGrabbedFrame()
{
    // texture 1 (poor quality scaling)
    glBindTexture(GL_TEXTURE_2D, frameTexture); // 2d texture (x and y size)

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // scale linearly when image bigger than texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // scale linearly when image smalled than texture

    // 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image,
    // border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
    glTexImage2D(GL_TEXTURE_2D, 0, 3, currentFrame.cols, currentFrame.rows,
				 0, GL_BGR, GL_UNSIGNED_BYTE, currentFrame.data);

	glBindTexture(GL_TEXTURE_2D, frameTexture); // choose the texture to use.

	glDisable(GL_LIGHTING);

	glMatrixMode(GL_PROJECTION);

		glLoadIdentity();

	glMatrixMode( GL_MODELVIEW );

		glLoadIdentity();

	glBegin(GL_QUADS);
		// Front Face (note that the texture's corners have to match the quad's corners)
		glNormal3f( 0.0f, 0.0f, 1.0f);  // Front face points out of the screen on z.
		glColor4f(1.0f,1.0f,1.0f,1.0f);

		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(-1.0f, -1.0,  0.0f);	// Bottom Left Of The Texture and Quad

		glTexCoord2f(1.0f, 1.0f);
		glVertex3f( 1.0f, -1.0,  0.0f);	// Bottom Right Of The Texture and Quad

		glTexCoord2f(1.0f, 0.0f);
		glVertex3f( 1.0f,  1.0f, 0.0f);	// Top Right Of The Texture and Quad

		glTexCoord2f(0.0f, 0.0f);
		glVertex3f( -1.0f,  1.0f,  0.0f);
	glEnd();

	glClear(GL_DEPTH_BUFFER_BIT);

	glBindTexture(GL_TEXTURE_2D, NULL);

	glEnable(GL_LIGHTING);
}

/* A general OpenGL initialization function. Sets all of the initial parameters. */
void InitGL(GLsizei Width, GLsizei Height)	//We call this right after our OpenGL window is created.
{
	setGLProjectionMatrix(projectionMatrix);

	glEnable(GL_TEXTURE_2D); // Enable texture mapping.

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f); // This Will Clear The Background Color To Black
	glClearDepth(1.0);					  // Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);				  // The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);			  // Enables Depth Testing
	glShadeModel(GL_SMOOTH);			  // Enables Smooth Color Shading

	glEnable ( GL_COLOR_MATERIAL ) ;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); // reset The Projection Matrix

	gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f); // calculate The Aspect Ratio Of The Window

	glMatrixMode(GL_MODELVIEW);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);

	glLightfv(GL_LIGHT1, GL_SPECULAR, LightSpecular);

	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse); // add lighting. (diffuse).
	glEnable(GL_LIGHT1);                            // turn light 1 on.
	glEnable(GL_LIGHTING);

	//generate texture
    glGenTextures(1, &frameTexture);
}

/* The function called whenever a normal key is pressed. */
void KeyPressed(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27: // kill everything.
		/* shut down our window */
		glutDestroyWindow(window);
		/* exit the program, normal termination. */
		exit(1);
		break; // redundant.
	case 's':
		start = !start;
	    detector2 = FaceDetector( frontalCascadeName,
							 profileCascadeName,
							 rEyeCascadeName,
							 lEyeCascadeName,
							 //noseCascadeName,
							 mouthCascadeName );
	case 'r':
		detected = false;
		break;
	case 'a':
		drawAxis = !drawAxis;
		break;
	case 'h':
		drawHead = !drawHead;
		break;
	case 'm':
		drawSine = !drawSine;
		break;
	case 't':
		drawText = !drawText;
		break;
	default:
		break;
	}
}

/* The main OpenGL drawing function. */
void DrawGLScene(void)
{
	camera >> currentFrame;
	t2 = (double)cvGetTickCount();
	double tT = t2;
	double dt = (t2-t1)/((double)cvGetTickFrequency()*1000000.);
	flip( currentFrame, currentFrame, 1 );

	/*if( start )
	{
		if( !detected )
			detected = detector.detect( currentFrame, scale );
		else
			detected = detector.update( currentFrame, dt );

		detector.draw( currentFrame );
	}*/

	if( start )
		detector2.faceDetect( currentFrame.data, 0, 0 );

	tT = (double)cvGetTickCount() - tT;
	//printf( "  update time = %g ms\n", dt*1000 );
	//printf( "tracking time = %g ms\n\n", tT/((double)cvGetTickFrequency()*1000.) );
	t1 = t2;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glEnable (GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	drawGrabbedFrame();

	glLightfv(GL_LIGHT1, GL_POSITION, LightPosition); //set light position.

	//loads reference point pose into OpenGL modelview matrix
	glMatrixMode( GL_PROJECTION );
	glLoadMatrixd( projectionMatrix );

	//look in +z direction, the same as POSIT
	gluLookAt( 0, 0, 0, 0, 0, +1.0, 0, -1, 0 );

	double glPositMatrix[16];
	detector2.getGlPositMatrix( glPositMatrix );

	glMatrixMode( GL_MODELVIEW );
	glLoadMatrixd( glPositMatrix );

	if( drawSine )
		drawSinusoidalHead(EHCIMODELSCALE);

	if( detector2.drawModel() )
	{
		if( drawAxis )
			drawCentralAxis();
		if( drawHead )
			drawHeadModel(1.4f/5.0f);
	}

	glutSwapBuffers();
}

void openGLCustomInit(int argc, char** argv ){

	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);

	/* get a 640 x 480 window */
	glutInitWindowSize(640, 480);

	/* the window starts at the upper left corner of the screen */
	glutInitWindowPosition(500, 0);

	/* Open a window */
	window = glutCreateWindow("openGL");

	/* Register the function to do all our OpenGL drawing. */
	glutDisplayFunc(&DrawGLScene);

	/* Even if there are no events, redraw our gl scene. */
	glutIdleFunc(&DrawGLScene);

	/* Register the function called when the keyboard is pressed. */
	glutKeyboardFunc(&KeyPressed);

	/* Initialize our window. */
	InitGL(640, 480);

	/* Start Event Processing Engine */
	glutMainLoop();
}

int main( int argc, char** argv )
{
    loadRaw( rawFile );

    camera = VideoCapture( CV_CAP_ANY );
    if( !camera.isOpened() )
    {
    	cout<< "Could not initialize capturing..." <<endl;
    	exit(-1);
    }

    cvNamedWindow( "result", 1 );

    openGLCustomInit( argc, argv );

    return 0;
}
